SystemOrganization addCategory: #'Magma seasideHelper'!

!Object methodsFor: '*magma seasideHelper' stamp: 'kph 10/29/2007 01:27'!
equals: a
	"this is liisted as an operator in MaClause, for use in Magma queries, duplicated here for
	MockMagmaCollection support"
	
	^ self = a! !

Object subclass: #WAServerManagedPreferences
	instanceVariableNames: 'preferences expiry'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma seasideHelper'!

!WAServerManagedPreferences class methodsFor: 'as yet unclassified' stamp: 'kph 10/29/2007 11:41'!
actualRootClass

	self error: 'should not be called on empty database'! !

!WAServerManagedPreferences class methodsFor: 'as yet unclassified' stamp: 'kph 10/29/2007 11:56'!
getVirtualRootIn: helper
	
	"Get the view-root of this pov"
	
	^ helper magmaSession root at: #prefs! !

!WAServerManagedPreferences class methodsFor: 'as yet unclassified' stamp: 'kph 10/29/2007 11:35'!
initializeVirtualRootIn: helper
	
	"initialize"
	
	self setVirtualRootIn: helper to: self new! !

!WAServerManagedPreferences class methodsFor: 'as yet unclassified' stamp: 'kph 10/29/2007 11:57'!
setVirtualRootIn: helper to: aServerManagementPreferences
	
	"Get the view-root of this pov"
	
	^ helper magmaSession root at: #prefs put: aServerManagementPreferences! !

!WAServerManagedPreferences methodsFor: 'as yet unclassified' stamp: 'kph 10/29/2007 11:17'!
expiry

	^ expiry! !

!WAServerManagedPreferences methodsFor: 'as yet unclassified' stamp: 'kph 10/29/2007 12:29'!
firstRead: helper

	self update < DateAndTime now ifTrue: [ self update: helper ]! !

!WAServerManagedPreferences methodsFor: 'as yet unclassified' stamp: 'kph 10/29/2007 11:16'!
initialize
	expiry := DateAndTime now! !

!WAServerManagedPreferences methodsFor: 'as yet unclassified' stamp: 'kph 10/29/2007 12:27'!
isCached

	^ false! !

!WAServerManagedPreferences methodsFor: 'as yet unclassified' stamp: 'kph 10/29/2007 11:18'!
preferences

	^ preferences! !

!WAServerManagedPreferences methodsFor: 'as yet unclassified' stamp: 'kph 10/29/2007 12:43'!
update: helper

	helper seasideSession application in: [ :app |
		self preferences keysAndValuesDo: [ :k :v | app preferenceAt: k put: v value ]
	]! !

!WASession methodsFor: '*magma seasidehelper' stamp: 'kph 10/29/2007 01:43'!
magma
	^ self helpers at: #magma ifAbsent: [ self error: 'Magma helper not selected in application configuration' ]! !

!MagmaCollection methodsFor: '*Magma seasideHelper' stamp: 'kph 10/28/2007 21:35'!
where: aBlock orSelect: bBlock
	 
	^ self where: aBlock! !

IdentityDictionary subclass: #WADictionaryRoot
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma seasideHelper'!

!WADictionaryRoot class methodsFor: 'as yet unclassified' stamp: 'kph 10/29/2007 11:40'!
actualRootClass
	
	"instanciate and initialize the preferred actual database root class"
	
	^ self ! !

!WADictionaryRoot class methodsFor: 'as yet unclassified' stamp: 'kph 10/29/2007 09:20'!
getVirtualRootIn: helper
	
	"Get the view-root of this pov"
	
	^ helper magmaSession root! !

!WADictionaryRoot class methodsFor: 'as yet unclassified' stamp: 'kph 10/29/2007 09:22'!
initializeVirtualRootIn: helper
	
	"initialize"
	
	self setVirtualRootIn: helper to: self new! !

!WADictionaryRoot class methodsFor: 'as yet unclassified' stamp: 'kph 10/29/2007 09:20'!
setVirtualRootIn: helper to: anObject
	
	"Set the view-root of this pov"
	
	^ helper magmaSession root: anObject! !

!WADictionaryRoot methodsFor: 'as yet unclassified' stamp: 'kph 10/29/2007 12:27'!
firstRead: helper

	"we do it this way to use auto initialization without contaminating #initialize
	neither do we define any additional methods that subclasses may not want.
	
	redefine this method in subclasses that do not need a firstRead: 
	
	or in databases which dont want the ServerManagedPreferences capability"
	
	helper rootAs: WAServerManagedPreferences ! !

IdentityDictionary subclass: #WAMagmaCollection
	instanceVariableNames: 'records'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma seasideHelper'!

!WAMagmaCollection class methodsFor: 'as yet unclassified' stamp: 'kph 10/29/2007 14:09'!
actualRootClass
	
	"instanciate and initialize the preferred actual database root class"
	
	^ self ! !

!WAMagmaCollection class methodsFor: 'as yet unclassified' stamp: 'kph 10/29/2007 14:09'!
getVirtualRootIn: helper
	
	"Get the view-root of this pov"
	
	^ helper magmaSession root! !

!WAMagmaCollection class methodsFor: 'as yet unclassified' stamp: 'kph 10/29/2007 14:09'!
initializeVirtualRootIn: helper
	
	"initialize"
	
	self setVirtualRootIn: helper to: self new! !

!WAMagmaCollection class methodsFor: 'as yet unclassified' stamp: 'kph 10/29/2007 14:09'!
setVirtualRootIn: helper to: anObject
	
	"Set the view-root of this pov"
	
	^ helper magmaSession root: anObject! !

!WAMagmaCollection methodsFor: 'as yet unclassified' stamp: 'kph 10/29/2007 14:09'!
firstRead: helper

 ! !

!WAMagmaCollection methodsFor: 'as yet unclassified' stamp: 'kph 10/29/2007 14:18'!
initialize

	records := WAMagma factory newMagmaCollection.

 ! !

!MagmaCollectionReader methodsFor: '*Magma seasideHelper' stamp: 'kph 10/28/2007 21:35'!
where: aBlock orSelect: bBlock
	 
	^ self where: aBlock! !

SortedCollection subclass: #WAMockMagmaCollection
	instanceVariableNames: 'indexes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma seasideHelper'!

!WAMockMagmaCollection commentStamp: 'kph 10/28/2007 20:58' prior: 0!
From Gjallar Q2MockMagmaCollection!

!WAMockMagmaCollection class methodsFor: 'as yet unclassified' stamp: 'gk 9/19/2006 13:59'!
new
	^super sortBlock: [:a :b | a hash <= b hash]! !

!WAMockMagmaCollection methodsFor: 'as yet unclassified' stamp: 'gk 4/5/2006 11:26'!
addIndex: anIndex

	^indexes at: anIndex attribute put: anIndex! !

!WAMockMagmaCollection methodsFor: 'as yet unclassified' stamp: 'kph 6/24/2007 17:22'!
at: i ifOutOfBounds: aBlock

	^ self at: i ifAbsent: aBlock ! !

!WAMockMagmaCollection methodsFor: 'as yet unclassified' stamp: 'gk 4/5/2006 11:26'!
hasIndexNamed: x

	^indexes includesKey: x! !

!WAMockMagmaCollection methodsFor: 'as yet unclassified' stamp: 'gk 4/5/2006 11:26'!
initialize

	super initialize.
	indexes := Dictionary new! !

!WAMockMagmaCollection methodsFor: 'as yet unclassified' stamp: 'makl 8/31/2006 12:33'!
pop
	| any |
	self isEmpty ifTrue: [^nil].
	any := self anyOne.
	self remove: any.
	^any! !

!WAMockMagmaCollection methodsFor: 'as yet unclassified' stamp: 'makl 8/31/2006 12:33'!
push: anObject
	self add: anObject! !

!WAMockMagmaCollection methodsFor: 'as yet unclassified' stamp: 'gk 4/5/2006 14:23'!
read: anIndex

	^self subset: self read: (indexes at: anIndex)! !

!WAMockMagmaCollection methodsFor: 'as yet unclassified' stamp: 'gk 8/10/2006 13:31'!
read: attributeSymbol at: key

	^ self
		read: attributeSymbol
		from: key
		to: key! !

!WAMockMagmaCollection methodsFor: 'as yet unclassified' stamp: 'gk 4/5/2006 13:06'!
read: anIndex from: start to: stop

	| subset index startHash stopHash |
	index := indexes at: anIndex.
	startHash := index indexHashForIndexObject: start.
	stopHash := index indexHashForIndexObject: stop.
	subset := self select: [:each |
		(index indexHashFor: each) between: startHash and: stopHash].
	^self subset: subset read: index
	! !

!WAMockMagmaCollection methodsFor: 'as yet unclassified' stamp: 'gk 10/5/2006 00:36'!
readUnique: index at: key
	"Return a single object or nil. Multiple hits cause error."

	| reader |
	reader _ self read: index at: key.
	reader size > 1 ifTrue: [self error: 'Multiple objects found with the same key when expecting only one'].
	^reader size = 1 ifTrue: [reader at: 1] ifFalse: [nil]! !

!WAMockMagmaCollection methodsFor: 'as yet unclassified' stamp: 'gk 4/6/2006 09:23'!
subset: sub read: anIndex
	sub sortBlock: [:a :b |
		(anIndex indexHashFor: a) < (anIndex indexHashFor: b)].
	^sub! !

!WAMockMagmaCollection methodsFor: 'as yet unclassified' stamp: 'kph 10/28/2007 21:34'!
where: aBlock
	"the closest we can manage to a read where is select:"
	^ aBlock select: self! !

!WAMockMagmaCollection methodsFor: 'as yet unclassified' stamp: 'kph 6/24/2007 17:38'!
where: aBlock orSelect: bBlock
	 
	^ self select: bBlock! !

WASessionHelper subclass: #WAMagma
	instanceVariableNames: 'seasideSession magmaSession root views'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma seasideHelper'!

!WAMagma commentStamp: 'kph 10/29/2007 12:53' prior: 0!
The aim of this version of the Magma-seaside integration framework is to learn some lessons from projects already using Magma in order to satisfy the following goals.

The overriding goal was to make the tutorial very easy, so as to blow away the competition!!

====
1. Simplify configuration. 
2. Ease combining Magma with other seaside technologies, to which end we do not subclass WASession.
3. Enable a choice of session management options such as shared or pooled sessions again orthogonal to the domain, or other settings.
4a. Facilitiate modularization, such that a Magma user-accounts module can be marketed as a standalone package, combinable with other modules, such as a pier module, or a shopping-cart module.
4b. Similarly, facilitate combination of projects having separate databases into one, e.g. gjallar & pier.
5. Simplify use and initialization, not just of the root object but also sub-branches of the database
   which are used by different application-modules or application sub-domains. 
6. Facilitate server managed preferences and data, multi-server operation, and load sharing schemes.

====

1.  The configuration provides a selector for the database helper class which provides session management. You can provide your own scheme by subclassing any of the WAMagma helper classes.

The local database directory, is initially set to 'Automatic' which will save the data in 'magma-todo' directory for the 'todo' entry point. This ensures that by default no configuration is required while at the same time separate applications will not step on each others databases files.

2. In order for Magma to be used alongside other frameworks which have specialized session classes such as Glorp, the configuration of Magma is now orthogonal to the choice of WASession. You may subclass WASession if you need to in order to support your application domain, but it is not necessary to do so in order to use Magma, or to store session state. Session state can be stored using the WASession-#properties dictionary.

This is accomplished through the WASessionHelper framework which is part of Seaside28Jetsam. Magma is supported by one such helper and the chosen Magma helper is accessed via WASession-#magma.

3. Magma helpers provide session management.
	single	- WAMagma
	shared	- WAMagmaShared
	pooled	- WAMagmaPooled
	mock	- WAMockMagma
	
4. Your custom accessors and queries onto the model for your domain are provided by subclassing typical model objects.
	typically, WADictionaryRoot, Object or MagmaCollection.

For example, to define an application specific model "ToDoList" for your database, subclass WADatabaseRoot (which is an IdentityDictionary) and define your custom accessors on that class e.g.

ToDoList-#items
^ self at: #items 

If items is a subclass of MagmaCollection called TodoListItemsCollection then you can define your custom item based queries on your own subclass, encouraging typical object-oriented encapsulation.

itemsForUser: name 
	self where: [ :each | each usersName equals: name ]

On your domain objects or components, access your database like so:

MyComponent-todoListDatabase
	^ self session magma rootAs: ToDoList

and...

MyComponent-todoListItems
	^ self todoListDatabase items
	
However for a sub-domain or module model you can also do.

MyComponent-todoListItems
	^ self session magma rootAs: TodoListItemsCollection
	
This means that the sub-domain or module models can be accessed in the domain irresepective of their place in the actual database structure, which is defined in your specialized model classes. They know where in the database they are located, and importantly they know how to initialize themselves.

This scheme allows several applications or sub-domains to be layered upon a single database. Each model class can nominates its own root object in the main database which is returned from the rootAs: idiom  (see class methods #getVirtualRootIn: #initializeVirtualRootIn: etc)

It also allows the database to be re-organised by changing model classes only. The domain view's are decoupled from the macro-structure of the database.

5. Initialization is performed automatically as far as is possible.

When using the standard accessor idiom: 'self session magma rootAs: MyModel'. If this is performed and the database does not exist, or has no root class, then, the root will automatically be initialized according to the #actualRootClass nominated by MyModel. Making databases auto-initializing. If the model object for MyModel is not present in the database, then it will also be initialized automatically.

The initialized root or model-objects are configured, and indexes added if needed, in their respective #initialize methods.

If a model is retrieved that is not of the correct class, #rootAs: attempts to mutate the instance into the desired class, thus providing some automatic schema migration at the module level.

6. Server managed preferences is provided by an optional module. This allows a seaside server application to pick up settings and preferences from the magma server. Whenever a new seaside session is started, on the first time only, the root objects #firstRead: method can call 'helper rootAs: WAServerManagedPreferences'.

WAServerManagedPreferences is implemented as a module, being as self contained as possible. It assumes the root object of the database is a dictionary (if not it will need to be reconfigured appropriately).

This module, when #firstRead:, checks its #expiry time, and if it has expired, it loads the current application's preferences with the values that it contains. The values are each sent #value before being written.

This would allow #location to return a version of MagmaRemoteLocation which when sent #value, evaluates picking a remove server based upon the client's itentity


Direct usage:
WAMagma helper may be used with Seaside, or directly. Configuration is per-seaside application e.g.

(WAMagma forApp: 'todo') location.
(WAMagma forApp: 'todo') readStrategyClass.
(WAMagma forApp: 'todo') areMaterializationNotificationsEnabled.
(WAMagma forApp: 'todo') commit: [].
 


!

!WAMagma class methodsFor: 'magma preferences' stamp: 'kph 10/28/2007 23:50'!
debugProxies: aBoolean

	MagmaPreferences debugProxies: aBoolean! !

!WAMagma class methodsFor: 'public factory methods' stamp: 'kph 10/28/2007 21:28'!
factory

	^ WACurrentSession value magma class! !

!WAMagma class methodsFor: 'helper protocol' stamp: 'kph 10/27/2007 05:40'!
isEnabledFor: app

	^ (app preferenceAt: #magmaHelperClass)  = self ! !

!WAMagma class methodsFor: 'public factory methods' stamp: 'kph 10/28/2007 21:42'!
newMagmaCollection
	"usage: WAMagma factory newNewMagmaCollection"
	^ MagmaCollection new! !

!WAMagma methodsFor: 'ops' stamp: 'kph 10/29/2007 00:40'!
abort

	self magmaSession abort! !

!WAMagma methodsFor: 'helper protocol' stamp: 'kph 11/16/2007 20:02'!
addHelperTo: helpers
	seasideSession := helpers session.
	super addHelperTo: helpers.
		! !

!WAMagma methodsFor: 'backup' stamp: 'kph 10/28/2007 23:31'!
backupDatabaseTo: aDirectory
	" Backup the database to aDirectory, and wait until the backup process ends. "

	| semaphoreWaitingForEndOfBackupProcess |
	semaphoreWaitingForEndOfBackupProcess := (self magmaSession repositoryController fullBackupTo: aDirectory).
	semaphoreWaitingForEndOfBackupProcess wait! !

!WAMagma methodsFor: 'ops' stamp: 'kph 10/29/2007 00:39'!
begin

	self magmaSession begin! !

!WAMagma methodsFor: 'ops' stamp: 'kph 10/28/2007 23:29'!
canStubOut: anObject

	^ self magmaSession canStubOut: anObject
! !

!WAMagma methodsFor: 'ops' stamp: 'kph 10/29/2007 03:27'!
commit: aBlock

	"we wrap the call to commit so that 'direct' users can make use of the factory"
	
	self during: [ :helper | helper magmaSession commit: aBlock ]! !

!WAMagma methodsFor: 'ops' stamp: 'kph 10/29/2007 03:33'!
create: aRootClass

	self location in: [ :loc |
		loc isLocal ifFalse: [ ^ self error: ' cannot create a non local database' ].
		
		loc path = 'Automatic'
			ifTrue: [ seasideSession application 
						preferenceAt: #location put: (loc copy path: 'magma-', seasideSession application name) ].
	].

	self during: [ :me |
		MagmaRepositoryController
			create: me location
			root: aRootClass new
	].

	"	
	(WAMagma forApp: 'todo') rootAs: StMagmaCollectionDatabase.
	
	WSUtilities cleanUpAll.
	"! !

!WAMagma methodsFor: 'ops' stamp: 'kph 10/29/2007 03:26'!
during: aBlock

	"we wrap the block as an aid so that 'direct' users can make use of the factory"
	
	^ WACurrentSession use: seasideSession during: [ aBlock value: self ]! !

!WAMagma methodsFor: 'server managed preferences' stamp: 'kph 10/29/2007 00:26'!
firstRead

	"When a new seaside session first accesses the database we get to make the first read if we want to"
	(root respondsTo: #prefsExpiry) ifFalse: [ ^ self ].
	
	 (root prefsExpiry ifNil: [ ^ self ]) > DateAndTime now ifTrue: [ self prefsRead ]! !

!WAMagma methodsFor: 'helper protocol' stamp: 'kph 10/27/2007 20:47'!
helperKey

^ #magma! !

!WAMagma methodsFor: 'configuration' stamp: 'kph 10/28/2007 23:27'!
info
	"the front end to the getOnceCache"
	
	^ self application preferenceAt: #location! !

!WAMagma methodsFor: 'ops' stamp: 'kph 11/16/2007 20:51'!
initialize
	views := IdentityDictionary new.
! !

!WAMagma methodsFor: 'configuration' stamp: 'kph 10/29/2007 01:52'!
location

	^ seasideSession application preferenceAt: #location! !

!WAMagma methodsFor: 'configuration' stamp: 'kph 10/28/2007 21:28'!
magmaHelperClass

 ^ self application preferenceAt: #magmaHelperClass! !

!WAMagma methodsFor: 'accessing' stamp: 'kph 10/29/2007 00:16'!
magmaSession

	^ magmaSession ifNil: [ magmaSession := self obtainMagmaSession ]! !

!WAMagma methodsFor: 'accessing' stamp: 'kph 10/29/2007 01:47'!
obtainMagmaSession
 
	magmaSession := self location newSessionAs: 'seaside'.

	magmaSession preferences signalProxyMaterializations: (self signalProxyMaterializations).
	self updateReadStrategy.

	^ magmaSession! !

!WAMagma methodsFor: 'ops' stamp: 'kph 10/29/2007 03:27'!
possiblyCommit: aBlock
	"This is a variant of #commit: in which we do #begin
	and then #commit if still #inTransaction. This makes
	it possible for code inside the block to abort and perform
	its own non-nested commits instead. We only commit at
	the end if we are still in a transaction.
 "

	^ self during: [:sess |
		| result |
		sess magmaSession begin.
		result := aBlock value.
		sess magmaSession inTransaction ifTrue: [sess magmaSession commit].
		result]! !

!WAMagma methodsFor: 'server managed preferences' stamp: 'kph 10/29/2007 00:25'!
prefsRead

	(root prefs ifNil: [ ^ nil ]) keysAndValuesDo: [ :k :v | self application preferenceAt: k put: v ].

 ! !

!WAMagma methodsFor: 'configuration' stamp: 'kph 10/28/2007 21:26'!
readStrategyClass

 ^ self application preferenceAt: #readStrategy! !

!WAMagma methodsFor: 'ops' stamp: 'kph 10/30/2007 21:29'!
rootAs: interfaceClass

	| viewRoot |
	"
	This is the default public interface onto the root of the database or onto a virtual view-root of a view onto the database.
	
	Views are sub-sections of the database, such that one database can be the combination of databases from 
	several separate applications combined. This facilitates modularization of the database schema,
	and utility access methods onto that schema.
	
	It presents the root from the point of view of this application, as defined by the given interfaceClass 
	
	When we obtain a root, or view-root, If it is nil we initialize it to be an instance of the nominated class.
	 
	If we find that the root class is not the class we anticipated we coerce it to given class for our users convenience
	(of course this will only work if the two are similar)
	
	This potentially allows a database to be shared among applications having different pov"

	"hit our cache first"
	views at: interfaceClass ifPresent: [ :v | ^ v ].
	
	"obtain the actual database root, if the database does not exist create it using the nominated root class" 
			
	root ifNil: [
		[ root := self magmaSession root ] 
			on: MagmaEnvironmentError 
			do: [ self create: interfaceClass actualRootClass new. 
				 root := self magmaSession ].
		root firstRead: self.
	].

	root ifNil: [ self error: 'root of database should not be nil' ].

	"map the actual root to the root of this view"

	viewRoot := interfaceClass getVirtualRootIn: self.

	viewRoot ifNil: [ self commit: [ interfaceClass initializeVirtualRootIn: self ].
					viewRoot := interfaceClass getVirtualRootIn: self.
					]. 
	
	 (viewRoot class = interfaceClass) ifFalse: [ 
			self commit: [ interfaceClass setVirtualRootIn: self to:  (interfaceClass adoptInstance: viewRoot from: viewRoot class) ]  ].

	viewRoot == root ifTrue: [ ^ viewRoot ].

	viewRoot firstRead: self.
	
	viewRoot isCached ifTrue: [ views at: interfaceClass put: viewRoot ].

	^ viewRoot
	! !

!WAMagma methodsFor: 'accessing' stamp: 'kph 10/29/2007 12:04'!
seasideSession

	^ seasideSession! !

!WAMagma methodsFor: 'ops' stamp: 'kph 11/16/2007 20:51'!
setUp: helpers
	 ! !

!WAMagma methodsFor: 'configuration' stamp: 'kph 10/29/2007 03:21'!
signalProxyMaterializations

 ^ seasideSession application preferenceAt: #signalProxyMaterializations! !

!WAMagma methodsFor: 'ops' stamp: 'kph 10/29/2007 01:01'!
start: aRequest in: session

	session useSessionCookie 
		ifTrue: [ session redirectWithCookie: session sessionCookie ].
	^ session mainClass new start: aRequest! !

!WAMagma methodsFor: 'ops' stamp: 'kph 10/28/2007 23:37'!
stubOut: anObject

	^ self magmaSession stubOut: anObject
! !

!WAMagma methodsFor: 'ops' stamp: 'kph 10/29/2007 00:42'!
submit: serverRequest

	^ self magmaSession submit: serverRequest 
! !

!WAMagma methodsFor: 'accessing' stamp: 'kph 10/29/2007 01:49'!
updateReadStrategy! !

WAMagma subclass: #WAMockMagma
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma seasideHelper'!

!WAMockMagma class methodsFor: 'as yet unclassified' stamp: 'kph 10/28/2007 21:32'!
newMagmaCollection
	^ WAMockMagmaCollection new! !
